## hydrogen 0.9.6~beta1

=== CMakeLists.txt ===
#
# CMAKE SETUP
#
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
# The CMake Policy mechanism is designed to help keep existing projects building as new versions of CMake introduce changes in behavior.
# http://www.cmake.org/cmake/help/cmake2.6docs.html#command:cmake_policy
IF(COMMAND CMAKE_POLICY)
#	CMAKE_POLICY(SET CMP0005 NEW)
	CMAKE_POLICY(SET CMP0003 NEW)   # add_library
	CMAKE_POLICY(SET CMP0006 NEW)   # bundle destination property
ENDIF()

#
# PROJECT INFO
#
PROJECT(hydrogen)
SET(VERSION_MAJOR "0")
SET(VERSION_MINOR "9")
SET(VERSION_PATCH "6")
SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
IF(VERSION_SUFFIX)
    SET(VERSION "${VERSION}-${VERSION_SUFFIX}")
ENDIF(VERSION_SUFFIX)
SET(LIBSNDFILE_VERSION_PREV "1.0.17")

#
# CONFIG OPTIONS
#
SET(WANT_LIBTAR TRUE)
OPTION(WANT_DEBUG       "build with debug information" ON)

IF(APPLE)
    OPTION(WANT_SHARED      "Build the core library shared." OFF)
ELSE()
    OPTION(WANT_SHARED      "Build the core library shared." ON)
ENDIF()

OPTION(WANT_LIBARCHIVE   "Enable use of libarchive instead of libtar" OFF)
OPTION(WANT_LADSPA       "Enable use of LADSPA plugins" ON)

IF(APPLE)
	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" OFF)
ELSE()
	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" ON)
ENDIF()

OPTION(WANT_OSS          "Include OSS (Open Sound System) support" OFF)
OPTION(WANT_ALSA         "Include ALSA (Advanced Linux Sound Architecture) support" ON)
OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
OPTION(WANT_PORTAUDIO    "Include PortAudio support" OFF)
OPTION(WANT_PORTMIDI     "Include PortMidi support" OFF)
OPTION(WANT_LASH         "Include LASH (Linux Audio Session Handler) support" OFF)
OPTION(WANT_LRDF         "Include LRDF (Lightweight Resource Description Framework with special support for LADSPA plugins) support" OFF)
OPTION(WANT_RUBBERBAND   "Include RUbberBand (Audio Time Stretcher Library) support" OFF)
IF(APPLE)
    OPTION(WANT_COREAUDIO   "Include CoreAudio support" ON)
    OPTION(WANT_COREMIDI    "Include CoreMidi support" ON)
    OPTION(WANT_BUNDLE  "Build a MAC OSX bundle application" ON)
ENDIF()

IF(WANT_DEBUG)
    SET(CMAKE_BUILD_TYPE Debug)
    SET(H2CORE_HAVE_DEBUG TRUE)
ELSE()
    SET(CMAKE_BUILD_TYPE Release)
    SET(H2CORE_HAVE_DEBUG FALSE)
ENDIF()

IF(WANT_BUNDLE)
    SET(H2CORE_HAVE_BUNDLE TRUE)
ELSE()
    SET(H2CORE_HAVE_BUNDLE FALSE)
ENDIF()

IF(WANT_SHARED)
    SET(H2CORE_LIBRARY_TYPE SHARED)
ELSE()
    SET(H2CORE_LIBRARY_TYPE STATIC)
ENDIF()

#SET(CMAKE_CXX_FLAGS "-fno-implement-inlines -finline-small-functions -findirect-inlining -fpartial-inlining")
SET(CMAKE_CXX_FLAGS "-O2 -fno-implement-inlines")
SET(CMAKE_CXX_FLAGS_RELEASE "")
SET(CMAKE_CXX_FLAGS_DEBUG "-g ")#-Winline")


IF(APPLE)
	#Compile for 32bit and 64bit intel macs
	SET (CMAKE_OSX_ARCHITECTURES "i386;x86_64;")
ENDIF()
#
# MANDATORY PKGS AND DEFAULT OPTIONS
#
INCLUDE(StatusSupportOptions)
MANDATORY_PKG(QT4)
MANDATORY_PKG(Threads)
MANDATORY_PKG(LIBSNDFILE)

# TODO remove data from path
SET(SYS_DATA_PATH "${CMAKE_INSTALL_PREFIX}/share/hydrogen/data")
# TODO remove data from path, could be .config/hydrogen
SET(USR_DATA_PATH ".hydrogen/data")
IF(WIN32)
    SET(WANT_JACK FALSE)
    SET(Threads_PATH "C:/Program Files/GnuWin32")
    SET(LIBARCHIVE_PATH "C:/Program Files/GnuWin32")
    SET(LIBSNDFILE_PATH "C:/Program Files/Mega-Nerd/libsndfile")
ELSE(WIN32)
    IF(APPLE)
        LINK_DIRECTORIES("/opt/local/lib")
    ELSE(APPLE)
        SET(OSS_LIB_PATHS "/usr/lib${LIB_SUFFIX}/oss/lib" "/usr/local/lib${LIB_SUFFIX}/oss/lib" )
        SET(RUBBERBAND_INCLUDE_PATHS "/usr/include/rubberband" )
    ENDIF(APPLE)
ENDIF(WIN32)

EXECUTE_PROCESS(COMMAND svnversion -n OUTPUT_VARIABLE REVISION )

#
# HEADER LIBRARY FUNCTIONS
#
INCLUDE(CompileHelper)
INCLUDE(FindHelper)
INCLUDE(FindLadspa)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(FindZLIB)
INCLUDE(FindThreads)
COMPILE_HELPER(SSCANF ${CMAKE_SOURCE_DIR}/cmake/sscanf sscanf )
COMPILE_HELPER(RTCLOCK ${CMAKE_SOURCE_DIR}/cmake/rtclock rtclock )
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(libtar.h HAVE_LIBTAR_H)
CHECK_LIBRARY_EXISTS(tar tar_open "" HAVE_LIBTAR_OPEN)
CHECK_LIBRARY_EXISTS(tar tar_close "" HAVE_LIBTAR_CLOSE)
CHECK_LIBRARY_EXISTS(tar tar_extract_all "" HAVE_LIBTAR_EXTRACT_ALL)
IF(HAVE_LIBTAR_H AND HAVE_LIBTAR_OPEN AND HAVE_LIBTAR_CLOSE AND HAVE_LIBTAR_EXTRACT_ALL)
    SET(LIBTAR_OK TRUE)
ELSE()
    SET(LIBTAR_OK FALSE)
ENDIF()
FIND_HELPER(LIBTAR tar tar.h tar)
IF( NOT LIBTAR_FOUND OR NOT LIBTAR_OK OR NOT ZLIB_FOUND )
    SET(WANT_LIBTAR FALSE)
    MANDATORY_PKG(LIBARCHIVE)
ENDIF()
FIND_HELPER(LIBARCHIVE archive archive.h archive)
IF( WANT_LIBARCHIVE AND LIBARCHIVE_FOUND)
    SET(WANT_LIBTAR FALSE)
ENDIF()
FIND_HELPER(LIBSNDFILE sndfile sndfile.h sndfile)
FIND_HELPER(ALSA alsa alsa/asoundlib.h asound )
FIND_LADSPA(LADSPA ladspa.h noise)
FIND_HELPER(OSS oss sys/soundcard.h OSSlib )
FIND_HELPER(JACK jack jack/jack.h jack)
FIND_HELPER(JACKSESSION jack jack/session.h jack)
IF(APPLE)
    FIND_LIBRARY(AUDIOUNIT_LIBRARY AudioUnit)
    FIND_LIBRARY(CORESERVICES_LIBRARY CoreServices)
    FIND_HELPER(COREAUDIO CoreAudio-2.0 coreaudio.h coreaudio)
    FIND_HELPER(COREMIDI CoreMidi coremidi.h coremidi)
ENDIF()
FIND_HELPER(PORTAUDIO portaudio-2.0 portaudio.h portaudio)
FIND_HELPER(PORTMIDI portmidi portmidi.h portmidi)
FIND_HELPER(LASH lash-1.0 lash/lash.h lash)
FIND_HELPER(LRDF lrdf lrdf.h lrdf)
FIND_HELPER(RUBBERBAND rubberband RubberBandStretcher.h rubberband)
# CHECK FOR Qt4
SET(QT_USE_QTNETWORK true)
SET(QT_USE_QTXML true)
SET(QT_USE_QTXMLPATTERNS true)
FIND_PACKAGE(Qt4 4.3.0 REQUIRED)

find_package(Doxygen)
if(DOXYGEN_FOUND)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
	add_custom_target(doc
		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs
		COMMENT "Generating API documentation with Doxygen" VERBATIM
		)
endif(DOXYGEN_FOUND)

#
# COMPUTE H2CORE_HAVE_xxx xxx_STATUS_REPORT
#
SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION COREAUDIO COREMIDI PORTAUDIO PORTMIDI LASH LRDF RUBBERBAND )
FOREACH( _pkg ${STATUS_LIST})
    COMPUTE_PKGS_FLAGS(${_pkg})
ENDFOREACH()

# LIBSNDFILE CHECKS
STRING( COMPARE GREATER "${LIBSNDFILE_VERSION}" "${LIBSNDFILE_VERSION_PREV}" LIBSNDFILE_VERSION_OK)
IF(LIBSNDFILE_VERSION_OK)
    SET(LIBSNDFILE_MSG "libsndfile supports FLAC and OGG sound file formats")
ELSE()
    SET(LIBSNDFILE_MSG "libsndfile version must be greater than ${LIBSNDFILE_VERSION_PREV} to support LFAC and OGG sound file formats")
ENDIF()

# RUBBERBAND information
SET(LIBRUBBERBAND_MSG "The use of librubberband2 is marked as experimental.
*				 Because the current implementation produce wrong timing!
*				 So long this bug isn't solved, please disable this option.
*				 If rubberband-cli is installed, the hydrogen rubberband-fuction
*				 will work properly as expected.")

#
# CONFIG PROCESS SUMMARY
#
SET(reset "${_escape}[0m")
SET(red "${_escape}[1;31m")
SET(purple "${_escape}[1;35m")
SET(cyan "${_escape}[1;36m")

COLOR_MESSAGE("${cyan}Installation Summary${reset}
--------------------
* Install Directory            : ${CMAKE_INSTALL_PREFIX}
* User data path               : ${USR_DATA_PATH}
* System data path             : ${SYS_DATA_PATH}
* core library build as        : ${H2CORE_LIBRARY_TYPE}
* debug capabilities           : ${H2CORE_HAVE_DEBUG}
* macosx bundle                : ${H2CORE_HAVE_BUNDLE}\n"
)

COLOR_MESSAGE("${cyan}Main librarires${reset}
* ${purple}libQt${reset}                        : ${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}
* ${purple}libsndfile${reset}                   : ${LIBSNDFILE_STATUS}
*                                ${LIBSNDFILE_MSG}
* ${purple}libtar${reset}                       : ${LIBTAR_STATUS}
* ${purple}libarchive${reset}                   : ${LIBARCHIVE_STATUS}
* ${purple}ladspa${reset}                       : ${LADSPA_STATUS}\n"
)

COLOR_MESSAGE("${cyan}Supported audio interfaces${reset}
--------------------------
* ${purple}ALSA${reset}                         : ${ALSA_STATUS}
* ${purple}OSS${reset}                          : ${OSS_STATUS}
* ${purple}JACK${reset}                         : ${JACK_STATUS}
* ${purple}JACKSESSION${reset}                  : ${JACKSESSION_STATUS}
* ${purple}CoreAudio${reset}                    : ${COREAUDIO_STATUS}
* ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
* ${purple}PortAudio${reset}                    : ${PORTAUDIO_STATUS}
* ${purple}PortMidi${reset}                     : ${PORTMIDI_STATUS}\n"
)

COLOR_MESSAGE("${cyan}Usefull extensions${reset}
-----------------------------------------
* ${purple}LASH${reset}                         : ${LASH_STATUS}
* ${purple}LRDF${reset}                         : ${LRDF_STATUS}
* ${purple}RUBBERBAND${reset}                   : ${RUBBERBAND_STATUS}
*                                ${LIBRUBBERBAND_MSG}\n"
)

IF(WANT_DEBUG)
    COLOR_MESSAGE("${cyan}Miscellaneous capabilities${reset}
-----------------------------------------
* realtime clock               : ${HAVE_RTCLOCK}
* working sscanf               : ${HAVE_SSCANF}\n"
    )
ENDIF()

COLOR_MESSAGE("-----------------------------------------------------------------
${red}IMPORTANT:${reset}
  after installing missing packages, remove ${CMAKE_BINARY_DIR}/CMakeCache.txt before
  running cmake again!
-----------------------------------------------------------------\n"
)

find_path( HYDROGEN_INSTALLED NAMES hydrogen/config.h )
IF( HYDROGEN_INSTALLED )
    COLOR_MESSAGE("-----------------------------------------------------------------
${red}IMPORTANT${reset}:
  previously installed hydrogen headers found in ${HYDROGEN_INSTALLED}
  you should uninstall these files before building hydrogen unless you know what you are doing.
-----------------------------------------------------------------\n"
    )
ENDIF()

#
# SET BUILD INFORMATION
#
ADD_SUBDIRECTORY(src/core)
ADD_SUBDIRECTORY(src/tests)
ADD_SUBDIRECTORY(src/cli)
ADD_SUBDIRECTORY(src/player)
ADD_SUBDIRECTORY(src/synth)
ADD_SUBDIRECTORY(src/gui)

INSTALL(DIRECTORY data DESTINATION ${SYS_DATA_PATH}/.. PATTERN ".svn" EXCLUDE)
IF(NOT WIN32 AND NOT APPLE)
    INSTALL(FILES ${CMAKE_SOURCE_DIR}/linux/hydrogen.desktop DESTINATION "${CMAKE_INSTALL_PREFIX}/share/applications")
ENDIF()

#
# CPack
#
INCLUDE(InstallRequiredSystemLibraries)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Hydrogen : an advanced drum machine for GNU/Linux")
SET(CPACK_PACKAGE_VENDOR "Hydrogen Developers")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.txt")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")

SET(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}")
IF(VERSION_SUFFIX)
    SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}-${VERSION_SUFFIX}")
ENDIF(VERSION_SUFFIX)

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "Hydrogen ${VERSION}")



IF(WIN32)
    # TODO
    #SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/data\\\\nsis_branding.bmp")
    SET(CPACK_NSIS_MUI_ICON "${CMAKE_SOURCE_DIR}/data\\\\hydrogen.ico")
    SET(CPACK_NSIS_INSTALLED_ICON_NAME "hydrogen.exe")
    SET(CPACK_NSIS_DISPLAY_NAME "Hydrogen (Advanced drum machine for GNU/Linux)")
    SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\www.hydrogen-music.org/")
    SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.hydrogen-music.org/")
    SET(CPACK_NSIS_CONTACT "hydrogen-devel@lists.sourceforge.net")
    SET(CPACK_PACKAGE_EXECUTABLES "hydrogen-gui.exe;Advanced drum machine for GNU/Linux")
    SET(CPACK_NSIS_MENU_LINKS "hydrogen-gui.exe;Advanced drum machine for GNU/Linux")
    SET(CPACK_SOURCE_GENERATOR "ZIP")
ELSE(WIN32)

=== debian/changelog ===
hydrogen (0.9.6~beta1-1ubuntu1) precise; urgency=low

  * Replace rsvg with rsvg-convert in debian/rules to prevent FTBFS with
    newer librsvg2-bin (LP: #935170)

 -- Alessio Treglia <quadrispro@ubuntu.com>  Sat, 18 Feb 2012 16:43:33 +0100

hydrogen (0.9.6~beta1-1) unstable; urgency=low

  * Team upload.
  * New upstream release.
  * Improve debian/watch file.
    - Detect upstream beta, alpha and rc releases.
  * Switch buildsystem from scons to cmake.
  * Replace negated list of non-linux architectures with linux-any.
  * Refresh debian/patches/09_portaudio_v2.patch.
  * Remove debian/patches/1002_relax_SCons_linux2_resolving.patch and
    other scons-specific patches as buildsystem has changed to cmake.
  * Refresh 1005_name_shouldnt_repeat_genericname.patch, plus some
    additions:
    - Remove deprecated FilePattern, Encoding keys.
    - Add trailing ';' to the MimeType field.
    - Remove unregistered 'Sound' value from Categories.
  * Remove 1006_werror_format_security.patch, applied upstream.
  * Add -lporttime to LDFLAGS to avoid FTBFS.
  * debian/copyright:
    - Fix lintian's copyright-refers-to-symlink-license warnings.
  * Don't install empty directories.
  * Delete development files and both shared and static objects for
    now, we'll introduce them once upstream will have released a
    stable release.

 -- Alessio Treglia <alessio@debian.org>  Fri, 27 Jan 2012 10:49:02 +0100

=== debian/control ===
Source: hydrogen
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>
Build-Depends: devscripts (>= 2.10.7~),
 cdbs (>= 0.4.73~),
 debhelper (>= 6),
 dh-buildinfo,
 cmake,
 libqt4-dev,
 libz-dev,
 pkg-config,
 libarchive-dev,
 docbook-utils,
 poxml,
 xmlto,
 libxml2-utils,
 libasound2-dev [linux-any],
 libaudiofile-dev,
 libjack-dev,
 liblrdf-dev,
 libsndfile1-dev (>= 1.0.18),
 portaudio19-dev,
 libportmidi-dev,
 librsvg2-bin,
 netpbm
Standards-Version: 3.9.2
Homepage: http://www.hydrogen-music.org/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/hydrogen.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/hydrogen.git;a=summary

Package: hydrogen
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: hydrogen-drumkits, rubberband-cli
Description: advanced drum machine/step sequencer
 Hydrogen is an advanced drum machine.  It's main goal is to bring
 professional yet simple and intuitive pattern-based drum programming.
 .
 General features:
  * Very user-friendly, modular, fast and intuitive graphical interface
    based on QT 4.
  * Sample-based stereo audio engine, with import of sound samples in
    .wav, .au and .aiff formats.
  * Support of samples in compressed FLAC file.
 .
 Sequencer and mixer features:
  * Pattern-based sequencer, with unlimited number of patterns and
    ability to chain patterns into a song.
  * Up to 64 ticks per pattern with individual level per event and
    variable pattern length.
  * 32 instrument tracks with volume, mute, solo, pan capabilities.
  * Multi layer support for instruments (up to 16 samples for each
    instrument).
  * Ability to import/export song files.
  * Unique human velocity, human time, pitch and swing functions.
  * Multiple patterns playing at once.
 .
 Other features:
  * JACK, ALSA, PortAudio and OSS audio drivers.
  * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
    ALL).
  * Import/export of drumkits.
  * Export song to wav file.
  * Export song to midi file.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2010, 2011 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for Hydrogen
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_CMAKE_EXTRA_FLAGS = -DWANT_SHARED=OFF \
 -DWANT_PORTAUDIO=ON \
 -DWANT_PORTMIDI=ON \
 -DWANT_RUBBERBAND=ON

DEB_UPSTREAM_URL = http://downloads.sourceforge.net/hydrogen

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^.*\.(flac|png|qm)|debian/(changelog|copyright(|_hints|_newhints))$

# according to upstream INSTALL.txt this avoids potential clash with Qt3
export QTDIR=/usr/share/qt4

DEB_INSTALL_MANPAGES_hydrogen = debian/hydrogen.1
DEB_INSTALL_EXAMPLES_hydrogen = extra/serverTools

# Put aside upstream-shipped autogenerated files during build
upstreamtmpfiles = $(wildcard data/doc/*.html data/doc/*.docbook)
upstreamtmpfiles_ = $(patsubst %.upstream,%,$(wildcard data/doc/*.html.upstream data/doc/*.docbook.upstream))
pre-build:: debian/stamp-upstreamtmpstuff
debian/stamp-upstreamtmpstuff: debian/stamp-copyright-check
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file ] || [ -e $$file.upstream ] || mv $$file $$file.upstream; \
	done
	touch $@
clean::
	for file in $(upstreamtmpfiles_); do \
		[ ! -e $$file.upstream ] || mv -f $$file.upstream $$file; \
	done
	rm -f debian/stamp-upstreamtmpstuff

common-build-indep:: debian/docs.stamp
debian/docs.stamp:
	$(MAKE) -C data/doc
	touch $@
clean::
	rm -f debian/docs.stamp

imgstub = data/img/gray/h2-icon
common-build-arch::
	#inkscape -z -e$(imgstub).png -D -w32 -h32 --export-area-snap $(imgstub).svg
	rsvg-convert -w 32 -h 32 -f png -o $(imgstub).png $(imgstub).svg
	pngtopnm -alpha $(imgstub).png > $(imgstub).alpha.pgm
	pngtopnm $(imgstub).png | ppmtoxpm -alphamask=$(imgstub).alpha.pgm > $(imgstub).xpm
	rm -f $(imgstub).png $(imgstub).alpha.pgm
clean::
	rm -f $(imgstub).xpm

# generate manpage based on --help of script itself
# TODO: make below rule work as part of main build
#common-post-build-arch:: debian/hydrogen.1
debian/hydrogen.1: hydrogen
	help2man --name="simple drum machine/step sequencer" --no-info --output=$@ $(DEB_SRCDIR)/$<
#clean::
#	rm -f debian/hydrogen.1

clean::
	rm -rf CMakeCache.txt CMakeFiles/ try/
	rm -f qt4.pyc version.cpp config.h

binary-install/hydrogen::
	find $(CURDIR)/debian/hydrogen/usr/share/ -type d -empty -delete
	rm -rf $(CURDIR)/debian/hydrogen/usr/lib/
	rm -rf $(CURDIR)/debian/hydrogen/usr/include/

# Needed by upstream build process
CDBS_BUILD_DEPENDS += , cmake
CDBS_BUILD_DEPENDS += , libqt4-dev, libz-dev, pkg-config, libarchive-dev
CDBS_BUILD_DEPENDS += , docbook-utils, poxml, xmlto, libxml2-utils
CDBS_BUILD_DEPENDS += , libasound2-dev [linux-any]
CDBS_BUILD_DEPENDS += , libaudiofile-dev, libjack-dev, liblrdf-dev, libsndfile1-dev (>= 1.0.18), portaudio19-dev, libportmidi-dev

# Needed for our packaging
# TODO: build-depend on help2man when solved using it with normal builds
#CDBS_BUILD_DEPENDS += , librsvg2-bin, netpbm, help2man
CDBS_BUILD_DEPENDS += , librsvg2-bin, netpbm

## hydrogen 0.9.6~beta2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #
 # CMAKE SETUP
 #
+
 CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
 SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
 # The CMake Policy mechanism is designed to help keep existing projects building as new versions of CMake introduce changes in behavior.
@@ -115,7 +116,7 @@
     ENDIF(APPLE)
 ENDIF(WIN32)
 
-EXECUTE_PROCESS(COMMAND svnversion -n OUTPUT_VARIABLE REVISION )
+EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE REVISION )
 
 #
 # HEADER LIBRARY FUNCTIONS
@@ -287,7 +288,7 @@
 ADD_SUBDIRECTORY(src/synth)
 ADD_SUBDIRECTORY(src/gui)
 
-INSTALL(DIRECTORY data DESTINATION ${SYS_DATA_PATH}/.. PATTERN ".svn" EXCLUDE)
+INSTALL(DIRECTORY data DESTINATION ${SYS_DATA_PATH}/.. PATTERN ".git" EXCLUDE)
 IF(NOT WIN32 AND NOT APPLE)
     INSTALL(FILES ${CMAKE_SOURCE_DIR}/linux/hydrogen.desktop DESTINATION "${CMAKE_INSTALL_PREFIX}/share/applications")
 ENDIF()

=== debian/changelog ===
hydrogen (0.9.6~beta2-1build1) raring; urgency=low

  * No-change rebuild for the libarchive13 transition.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 24 Feb 2013 14:51:48 -0700

hydrogen (0.9.6~beta2-1) unstable; urgency=low

  * Team upload.
  * New upstream release.
  * Refresh patches.
  * Don't install extra/serverTools directory, it is no longer provided.
  * Fix off-by-one error in JACK MIDI.
    Thanks to Roland Mas for the patch! (Closes: #661725)

 -- Alessio Treglia <alessio@debian.org>  Tue, 12 Jun 2012 11:50:06 +0200

hydrogen (0.9.6~beta1-3) unstable; urgency=low

  * Team upload.

  [ Adrian Knoth ]
  * Add patch to fix FTBFS with gcc-4.7 (Closes: #667203).

  [ Alessio Treglia ]
  * Update debian/copyright to machine-readable format.
  * Bump Standards-Version.
  * Regenerate debian/control.

 -- Alessio Treglia <alessio@debian.org>  Tue, 08 May 2012 11:28:41 -0700

hydrogen (0.9.6~beta1-2) unstable; urgency=low

  * Replace rsvg with rsvg-convert to convert SVG to PNG image (LP: #935170):
    - Future versions of librsvg won't provide the 'rsvg' tool anymore.

 -- Alessio Treglia <alessio@debian.org>  Sat, 18 Feb 2012 17:46:48 +0100

## hydrogen 0.9.6~beta3

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,9 +19,16 @@
 SET(VERSION_MAJOR "0")
 SET(VERSION_MINOR "9")
 SET(VERSION_PATCH "6")
+SET(VERSION_SUFFIX "beta3")
+
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
+
+
 IF(VERSION_SUFFIX)
-    SET(VERSION "${VERSION}-${VERSION_SUFFIX}")
+	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
+ELSE() 
+	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
+	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
 ENDIF(VERSION_SUFFIX)
 SET(LIBSNDFILE_VERSION_PREV "1.0.17")
 
@@ -116,7 +123,6 @@
     ENDIF(APPLE)
 ENDIF(WIN32)
 
-EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE REVISION )
 
 #
 # HEADER LIBRARY FUNCTIONS
@@ -324,6 +330,3 @@
     SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.hydrogen-music.org/")
     SET(CPACK_NSIS_CONTACT "hydrogen-devel@lists.sourceforge.net")
     SET(CPACK_PACKAGE_EXECUTABLES "hydrogen-gui.exe;Advanced drum machine for GNU/Linux")
-    SET(CPACK_NSIS_MENU_LINKS "hydrogen-gui.exe;Advanced drum machine for GNU/Linux")
-    SET(CPACK_SOURCE_GENERATOR "ZIP")
-ELSE(WIN32)

=== src/cli/CMakeLists.txt ===

FILE(GLOB_RECURSE h2cli_SRCS *.cpp)

INCLUDE_DIRECTORIES(
    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
    ${QT_INCLUDES}
    ${LASH_INCLUDE_DIR}
)

ADD_EXECUTABLE(h2cli WIN32 MACOSX_BUNDLE ${h2cli_SRCS} )
TARGET_LINK_LIBRARIES(h2cli
    hydrogen-core-${VERSION}
    ${QT_QTGUI_LIBRARY}
    ${LASH_LIBRARIES}
)

ADD_DEPENDENCIES(h2cli hydrogen-core-${VERSION})

INSTALL(TARGETS h2cli RUNTIME DESTINATION bin BUNDLE DESTINATION bin )

=== src/gui/CMakeLists.txt ===

FILE(GLOB_RECURSE hydrogen_H src/*.h)
FILE(GLOB_RECURSE hydrogen_UIS src/*.ui)
FILE(GLOB_RECURSE hydrogen_SRCS src/*.cpp)

# add undiscovered dependencies to generated config.h
INCLUDE(AddFileDependencies)
FOREACH( _file ${hydrogen_H} ${hydrogen_SRCS})
    FILE(READ "${_file}" _FILE_CONTENT)
    IF( "${_FILE_CONTENT}" MATCHES "H2CORE_HAVE_" )
        ADD_FILE_DEPENDENCIES( ${_file} ${CMAKE_BINARY_DIR}/src/core/include/hydrogen/config.h)
    ENDIF()
ENDFOREACH()

QT4_WRAP_UI(hydrogen_UIS_H ${hydrogen_UIS})             # ui_ files are generated in CMAKE_CURRENT_BINARY_DIR
QT4_WRAP_CPP(hydrogen_MOC ${hydrogen_H} OPTIONS -nw) 

INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_BINARY_DIR}                 # ui_ headers
    ${CMAKE_CURRENT_SOURCE_DIR}/src             # gui headers
    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
    ${LASH_INCLUDE_DIR}
    ${QT_INCLUDES}
)

IF(APPLE)
	# set how it shows up in the Info.plist file
     	SET(MACOSX_BUNDLE_INFO_STRING "Hydrogen for Mac")
	SET(MACOSX_BUNDLE_ICON_FILE "icon.icns")
	SET(MACOSX_BUNDLE_GUI_IDENTIFIER "Hydrogen")
	SET(MACOSX_BUNDLE_LONG_VERSION_STRING "${VERSION}")
	#this has to be short since it appears as the application name in the menu bar
	SET(MACOSX_BUNDLE_BUNDLE_NAME "Hydrogen")
	SET(MACOSX_BUNDLE_SHORT_VERSION_STRING "${VERSION}")
	SET(MACOSX_BUNDLE_BUNDLE_VERSION "${VERSION}")
	SET(MACOSX_BUNDLE_COPYRIGHT "Hydrogen Developers, 2009")

  	# set where in the bundle to put the icns file
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/data/img/gray/icon.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	# include the icns file in the target
	SET(hydrogen_SRCS ${hydrogen_SRCS} ${CMAKE_SOURCE_DIR}/data/img/gray/icon.icns)
	
	#copy the data folder
	FILE(COPY ${CMAKE_SOURCE_DIR}/data DESTINATION hydrogen.app/Contents/Resources PATTERN ".svn" EXCLUDE)
  	
ENDIF()


ADD_EXECUTABLE(hydrogen WIN32 MACOSX_BUNDLE ${hydrogen_SRCS} ${hydrogen_MOC} ${hydrogen_UIS_H})
TARGET_LINK_LIBRARIES(hydrogen
    hydrogen-core-${VERSION}
    ${QT_QTGUI_LIBRARY}
    ${QT_QTNETWORK_LIBRARY}
)

ADD_DEPENDENCIES(hydrogen hydrogen-core-${VERSION})

INSTALL(TARGETS hydrogen RUNTIME DESTINATION bin BUNDLE DESTINATION bin )

=== src/synth/CMakeLists.txt ===

FILE(GLOB_RECURSE h2synth_SRCS *.cpp)

INCLUDE_DIRECTORIES(
    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
    ${QT_INCLUDES}
)

ADD_EXECUTABLE(h2synth WIN32 MACOSX_BUNDLE ${h2synth_SRCS} )
TARGET_LINK_LIBRARIES(h2synth
    hydrogen-core-${VERSION}
    ${QT_QTGUI_LIBRARY}
)

ADD_DEPENDENCIES(h2synth hydrogen-core-${VERSION})

INSTALL(TARGETS h2synth RUNTIME DESTINATION bin BUNDLE DESTINATION bin )

=== src/tests/CMakeLists.txt ===

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
add_definitions()
include_directories(
    ${CMAKE_SOURCE_DIR}/src/core/include            # core headers
    ${CMAKE_BINARY_DIR}/src/core/include            # generated config.h
    ${QT_INCLUDES}                                  # TODO be able to remove this
)
FILE(GLOB_RECURSE TESTS_SRCS *.cpp)
link_directories()
add_executable(tests ${TESTS_SRCS})
target_link_libraries(tests
    hydrogen-core-${VERSION}
)
add_dependencies(tests hydrogen-core-${VERSION})

=== debian/changelog ===
hydrogen (0.9.6~beta3-1) unstable; urgency=low

  * Team upload.

  [ Jonas Smedegaard ]
  * Update README.source to emphasize control.in file as *not* a
    show-stopper for contributions, referring to wiki page for details.

  [ Alessio Treglia ]
  * New upstream release.
  * Refresh debian/patches/09_portaudio_v2.patch.
  * Drop 1007_off_by_one_in_jackmidi.patch, applied upstream.

 -- Alessio Treglia <alessio@debian.org>  Fri, 04 Oct 2013 15:19:02 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: hydrogen
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
-Uploaders: Jonas Smedegaard <dr@jones.dk>
-Build-Depends: devscripts (>= 2.10.7~),
- cdbs (>= 0.4.73~),
- debhelper (>= 6),
+Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Uploaders:
+ Jonas Smedegaard <dr@jones.dk>
+Build-Depends:
+ cdbs (>= 0.4.70~),
+ devscripts,
+ debhelper,
  dh-buildinfo,
  cmake,
  libqt4-dev,
@@ -26,15 +27,19 @@
  libportmidi-dev,
  librsvg2-bin,
  netpbm
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://www.hydrogen-music.org/
 Vcs-Git: git://git.debian.org/git/pkg-multimedia/hydrogen.git
 Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/hydrogen.git;a=summary
 
 Package: hydrogen
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: hydrogen-drumkits, rubberband-cli
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends}
+Recommends:
+ hydrogen-drumkits,
+ rubberband-cli
 Description: advanced drum machine/step sequencer
  Hydrogen is an advanced drum machine.  It's main goal is to bring
  professional yet simple and intuitive pattern-based drum programming.

=== debian/rules ===
--- 
+++ 
@@ -34,7 +34,6 @@
 export QTDIR=/usr/share/qt4
 
 DEB_INSTALL_MANPAGES_hydrogen = debian/hydrogen.1
-DEB_INSTALL_EXAMPLES_hydrogen = extra/serverTools
 
 # Put aside upstream-shipped autogenerated files during build
 upstreamtmpfiles = $(wildcard data/doc/*.html data/doc/*.docbook)

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=3
opts=uversionmangle=s/-(beta|alpha|rc)/~$1/ \
http://sf.net/hydrogen/hydrogen-(.+)\.tar\.gz

## hydrogen 0.9.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,24 +19,26 @@
 SET(VERSION_MAJOR "0")
 SET(VERSION_MINOR "9")
 SET(VERSION_PATCH "6")
-SET(VERSION_SUFFIX "beta3")
-
-SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
-
-
-IF(VERSION_SUFFIX)
-	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
-ELSE() 
-	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
-	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
-ENDIF(VERSION_SUFFIX)
+SET(VERSION_PATCH2 "1")
+#SET(VERSION_SUFFIX "RC2")
+
+SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_PATCH2}")
+SET(DISPLAY_VERSION "${VERSION}")
+
+#IF(VERSION_SUFFIX)
+#	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
+#ELSE() 
+#	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
+#	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
+#ENDIF(VERSION_SUFFIX)
+
 SET(LIBSNDFILE_VERSION_PREV "1.0.17")
 
 #
 # CONFIG OPTIONS
 #
 SET(WANT_LIBTAR TRUE)
-OPTION(WANT_DEBUG       "build with debug information" ON)
+OPTION(WANT_DEBUG       "build with debug information" OFF)
 
 IF(APPLE)
     OPTION(WANT_SHARED      "Build the core library shared." OFF)
@@ -44,7 +46,7 @@
     OPTION(WANT_SHARED      "Build the core library shared." ON)
 ENDIF()
 
-OPTION(WANT_LIBARCHIVE   "Enable use of libarchive instead of libtar" OFF)
+OPTION(WANT_LIBARCHIVE   "Enable use of libarchive instead of libtar" ON)
 OPTION(WANT_LADSPA       "Enable use of LADSPA plugins" ON)
 
 IF(APPLE)
@@ -53,11 +55,17 @@
 	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" ON)
 ENDIF()
 
-OPTION(WANT_OSS          "Include OSS (Open Sound System) support" OFF)
+IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
+	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" ON)
+ELSE()
+	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" OFF)
+ENDIF()
+
 OPTION(WANT_ALSA         "Include ALSA (Advanced Linux Sound Architecture) support" ON)
 OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
 OPTION(WANT_PORTAUDIO    "Include PortAudio support" OFF)
 OPTION(WANT_PORTMIDI     "Include PortMidi support" OFF)
+OPTION(WANT_PULSEAUDIO   "Include PulseAudio support" ON)
 OPTION(WANT_LASH         "Include LASH (Linux Audio Session Handler) support" OFF)
 OPTION(WANT_LRDF         "Include LRDF (Lightweight Resource Description Framework with special support for LADSPA plugins) support" OFF)
 OPTION(WANT_RUBBERBAND   "Include RUbberBand (Audio Time Stretcher Library) support" OFF)
@@ -66,6 +74,7 @@
     OPTION(WANT_COREMIDI    "Include CoreMidi support" ON)
     OPTION(WANT_BUNDLE  "Build a MAC OSX bundle application" ON)
 ENDIF()
+OPTION(WANT_CPPUNIT      "Include CppUnit test suite" ON)
 
 IF(WANT_DEBUG)
     SET(CMAKE_BUILD_TYPE Debug)
@@ -88,14 +97,20 @@
 ENDIF()
 
 #SET(CMAKE_CXX_FLAGS "-fno-implement-inlines -finline-small-functions -findirect-inlining -fpartial-inlining")
-SET(CMAKE_CXX_FLAGS "-O2 -fno-implement-inlines")
+IF(APPLE)
+	SET(CMAKE_CXX_FLAGS "-O2")
+ELSE()
+	SET(CMAKE_CXX_FLAGS "-O2 -fno-implement-inlines")
+ENDIF()
+
 SET(CMAKE_CXX_FLAGS_RELEASE "")
+
 SET(CMAKE_CXX_FLAGS_DEBUG "-g ")#-Winline")
 
 
 IF(APPLE)
 	#Compile for 32bit and 64bit intel macs
-	SET (CMAKE_OSX_ARCHITECTURES "i386;x86_64;")
+	SET (CMAKE_OSX_ARCHITECTURES "x86_64;")
 ENDIF()
 #
 # MANDATORY PKGS AND DEFAULT OPTIONS
@@ -159,7 +174,13 @@
 FIND_HELPER(LIBSNDFILE sndfile sndfile.h sndfile)
 FIND_HELPER(ALSA alsa alsa/asoundlib.h asound )
 FIND_LADSPA(LADSPA ladspa.h noise)
-FIND_HELPER(OSS oss sys/soundcard.h OSSlib )
+
+IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
+	FIND_HELPER(OSS oss sys/soundcard.h ossaudio )
+ELSE()
+	FIND_HELPER(OSS oss sys/soundcard.h OSSlib )
+ENDIF()
+
 FIND_HELPER(JACK jack jack/jack.h jack)
 FIND_HELPER(JACKSESSION jack jack/session.h jack)
 IF(APPLE)
@@ -170,12 +191,21 @@
 ENDIF()
 FIND_HELPER(PORTAUDIO portaudio-2.0 portaudio.h portaudio)
 FIND_HELPER(PORTMIDI portmidi portmidi.h portmidi)
+FIND_HELPER(PULSEAUDIO pulseaudio pulse/pulseaudio.h pulse)
 FIND_HELPER(LASH lash-1.0 lash/lash.h lash)
 FIND_HELPER(LRDF lrdf lrdf.h lrdf)
+
+IF(LRDF_FOUND)
+	include_directories(${LRDF_INCLUDE_DIRS}) # see github issue 194
+ENDIF(LRDF_FOUND)
+
 FIND_HELPER(RUBBERBAND rubberband RubberBandStretcher.h rubberband)
+FIND_HELPER(CPPUNIT cppunit cppunit/TestCase.h cppunit)
+
 # CHECK FOR Qt4
 SET(QT_USE_QTNETWORK true)
 SET(QT_USE_QTXML true)
+SET(QT_USE_QTGUI true)
 SET(QT_USE_QTXMLPATTERNS true)
 FIND_PACKAGE(Qt4 4.3.0 REQUIRED)
 
@@ -192,7 +222,7 @@
 #
 # COMPUTE H2CORE_HAVE_xxx xxx_STATUS_REPORT
 #
-SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION COREAUDIO COREMIDI PORTAUDIO PORTMIDI LASH LRDF RUBBERBAND )
+SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RUBBERBAND CPPUNIT )
 FOREACH( _pkg ${STATUS_LIST})
     COMPUTE_PKGS_FLAGS(${_pkg})
 ENDFOREACH()
@@ -248,7 +278,8 @@
 * ${purple}CoreAudio${reset}                    : ${COREAUDIO_STATUS}
 * ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
 * ${purple}PortAudio${reset}                    : ${PORTAUDIO_STATUS}
-* ${purple}PortMidi${reset}                     : ${PORTMIDI_STATUS}\n"
+* ${purple}PortMidi${reset}                     : ${PORTMIDI_STATUS}
+* ${purple}PulseAudio${reset}                   : ${PULSEAUDIO_STATUS}\n"
 )
 
 COLOR_MESSAGE("${cyan}Usefull extensions${reset}
@@ -263,7 +294,8 @@
     COLOR_MESSAGE("${cyan}Miscellaneous capabilities${reset}
 -----------------------------------------
 * realtime clock               : ${HAVE_RTCLOCK}
-* working sscanf               : ${HAVE_SSCANF}\n"
+* working sscanf               : ${HAVE_SSCANF}
+* unit tests                   : ${CPPUNIT_STATUS}\n"
     )
 ENDIF()
 
@@ -288,7 +320,9 @@
 # SET BUILD INFORMATION
 #
 ADD_SUBDIRECTORY(src/core)
-ADD_SUBDIRECTORY(src/tests)
+IF(H2CORE_HAVE_CPPUNIT)
+    ADD_SUBDIRECTORY(src/tests)
+ENDIF()
 ADD_SUBDIRECTORY(src/cli)
 ADD_SUBDIRECTORY(src/player)
 ADD_SUBDIRECTORY(src/synth)
@@ -310,23 +344,3 @@
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
 
 SET(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
-SET(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
-SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}")
-IF(VERSION_SUFFIX)
-    SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}-${VERSION_SUFFIX}")
-ENDIF(VERSION_SUFFIX)
-
-SET(CPACK_PACKAGE_INSTALL_DIRECTORY "Hydrogen ${VERSION}")
-
-
-
-IF(WIN32)
-    # TODO
-    #SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/data\\\\nsis_branding.bmp")
-    SET(CPACK_NSIS_MUI_ICON "${CMAKE_SOURCE_DIR}/data\\\\hydrogen.ico")
-    SET(CPACK_NSIS_INSTALLED_ICON_NAME "hydrogen.exe")
-    SET(CPACK_NSIS_DISPLAY_NAME "Hydrogen (Advanced drum machine for GNU/Linux)")
-    SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\www.hydrogen-music.org/")
-    SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.hydrogen-music.org/")
-    SET(CPACK_NSIS_CONTACT "hydrogen-devel@lists.sourceforge.net")
-    SET(CPACK_PACKAGE_EXECUTABLES "hydrogen-gui.exe;Advanced drum machine for GNU/Linux")

=== cmake/sscanf/CMakeLists.txt ===

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
add_definitions()
include_directories()
link_directories()
add_executable(sscanf sscanf.c)
target_link_libraries(sscanf  )

=== data/doc/Makefile ===
###
### must have the following commandline tools:
###
### xml2po  (Debian package: poxml)
### po2xml  (Debian package: poxml)
### xmlto   (Debian package: xmlto)
### xmllint (Debian package: libxml2-utils)
###

MANUAL_MASTER = manual.docbook
TUTORIAL_MASTER = tutorial.docbook

ALL_MASTERS = $(MANUAL_MASTER) $(TUTORIAL_MASTER)

ALL_MANUALS = manual_en.html \
	manual_es.html \
	manual_fr.html \
	manual_it.html \
	manual_ca.html \
	manual_nl.html

ALL_TUTORIALS = tutorial_en.html \
	tutorial_fr.html \
	tutorial_it.html

ALL_POT_FILES = manual_en.pot tutorial_en.pot

XMLTO_OPTS = --stringparam section.autolabel=1 \
	--stringparam toc.max.depth=2 \
	--stringparam xref.with.number.and.title=0

XML2POT = xml2pot
XMLTO = xmlto
XMLLINT = xmllint
PO2XML = po2xml

all: all_manuals all_tutorials all_pot_files

all_manuals: $(ALL_MANUALS)

all_tutorials: $(ALL_TUTORIALS)

## Explicit build to avoid circular dependency
all_pot_files: $(ALL_MASTERS)
	$(XML2POT) manual.docbook   > manual.pot
	$(XML2POT) tutorial.docbook > tutorial.pot

clean:
	-rm -f $(ALL_MANUALS) $(ALL_TUTORIALS) *_{en,es,it,fr,nl,ca}.docbook *.docbook_validated

%.html: %.docbook %.docbook_validated
	LL=$$(echo -n $< | sed 's/.*_\(..\)\.docbook/\1/') ; \
	$(XMLTO) html-nochunks $(XMLTO_OPTS) \
		--stringparam l10n.gentext.language=$$LL \
		$<

%.docbook_validated: %.docbook
	$(XMLLINT) --noout --valid $^
	touch $@

## Special rule for master manual and tutorial
%_en.docbook: %.docbook
	cp -f $^ $@

manual_%.docbook: manual_%.po $(MANUAL_MASTER)
	$(PO2XML) $(MANUAL_MASTER) $< > $@

#manual_%.po: $(MANUAL_MASTER)
#	$(XML2POT) -u $@ $^

tutorial_%.docbook: tutorial_%.po $(TUTORIAL_MASTER)
	$(PO2XML) $(TUTORIAL_MASTER) $< > $@

#tutorial_%.po: $(TUTORIAL_MASTER)
#	$(XML2POT) -u $@ $^

=== src/core/CMakeLists.txt ===

CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/include/hydrogen/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h" @ONLY)

FILE(GLOB_RECURSE hydrogen_INCLUDES include/*.h)
FILE(GLOB_RECURSE hydrogen_SOURCES src/*.cpp src/*.cc src/*.c)
LIST(APPEND hydrogen_INCLUDES ${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h)

ADD_LIBRARY( hydrogen-core-${VERSION} ${H2CORE_LIBRARY_TYPE} ${hydrogen_SOURCES})
INCLUDE_DIRECTORIES( include
    ${CMAKE_SOURCE_DIR}/include                 # regular headers
    ${CMAKE_CURRENT_BINARY_DIR}/include         # generated config.h
    ${QT_INCLUDES}
    ${LIBTAR_INCLUDE_DIR}
    ${LIBARCHIVE_INCLUDE_DIR}
    ${LIBSNDFILE_INCLUDE_DIR}
    ${ALSA_INCLUDE_DIR}
    ${OSS_INCLUDE_DIR}
    ${JACK_INCLUDE_DIR}
    ${PORTAUDIO_INCLUDE_DIR}
    ${PORTMIDI_INCLUDE_DIR}
    ${COREAUDIO_INCLUDE_DIR}
    ${COREMIDI_INCLUDE_DIR}
    ${LASH_INCLUDE_DIR}
    ${LRDF_INCLUDE_DIR}
    ${RUBBERBAND_INCLUDE_DIR}
)

TARGET_LINK_LIBRARIES(hydrogen-core-${VERSION}
    ${QT_QTCORE_LIBRARY}
    ${QT_QTXML_LIBRARY}
    ${QT_QTXMLPATTERNS_LIBRARY}
    ${LIBTAR_LIBRARIES}
    ${LIBARCHIVE_LIBRARIES}
    ${LIBSNDFILE_LIBRARIES}
    ${ALSA_LIBRARIES}
    ${OSS_LIBRARIES}
    ${JACK_LIBRARIES}
    ${PORTAUDIO_LIBRARIES}
    ${PORTMIDI_LIBRARIES}
    ${AUDIOUNIT_LIBRARY}
    ${CORESERVICES_LIBRARY}
    ${COREAUDIO_LIBRARIES}
    ${COREMIDI_LIBRARIES}
    ${PULSEAUDIO_LIBRARIES}
    ${LASH_LIBRARIES}
    ${LRDF_LIBRARIES}
    ${RUBBERBAND_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
)

#SET_TARGET_PROPERTIES(hydrogen-core-${VERSION} PROPERTIES PUBLIC_HEADER   "${hydrogen_INCLUDES}" )

INSTALL(TARGETS hydrogen-core-${VERSION}
    LIBRARY DESTINATION "lib${LIB_SUFFIX}"
    ARCHIVE DESTINATION "lib${LIB_SUFFIX}"
    # do not copy directory hierarchy
    #PUBLIC_HEADER DESTINATION include/hydrogen
)

IF(NOT APPPLE AND NOT WIN32)
    INSTALL(DIRECTORY include DESTINATION "${CMAKE_INSTALL_PREFIX}" FILES_MATCHING PATTERN "*.h" PATTERN ".svn" EXCLUDE)
    INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/include/hydrogen/config.h" DESTINATION "${CMAKE_INSTALL_PREFIX}/include/hydrogen" )
ENDIF()

=== src/player/CMakeLists.txt ===

FILE(GLOB_RECURSE h2player_SRCS *.cpp)

INCLUDE_DIRECTORIES(
    ${CMAKE_SOURCE_DIR}/src/core/include        # core headers
    ${CMAKE_BINARY_DIR}/src/core/include        # generated config.h
    ${QT_INCLUDES}
)

ADD_EXECUTABLE(h2player WIN32 MACOSX_BUNDLE ${h2player_SRCS} )
TARGET_LINK_LIBRARIES(h2player
    hydrogen-core-${VERSION}
    ${QT_QTGUI_LIBRARY}
)

ADD_DEPENDENCIES(h2player hydrogen-core-${VERSION})

INSTALL(TARGETS h2player RUNTIME DESTINATION bin BUNDLE DESTINATION bin )

=== debian/changelog ===
hydrogen (0.9.6.1-1build1) wily; urgency=medium

  * No-change rebuild against libjack-jackd2-0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 11 Aug 2015 06:43:35 +0000

hydrogen (0.9.6.1-1) unstable; urgency=medium

  * Bump Standards.
  * Set dh/compat 9.
  * Fix use canonical Vcs-Git URL.
  * Add Keywords to desktop file.
  * Update copyright file.
  * Add myself as uploader.
  * Add libpulse-dev as build-dep.
  * Add librubberband-dev as build-dep.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 21 Oct 2014 14:02:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: hydrogen
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
- Jonas Smedegaard <dr@jones.dk>
+ Jonas Smedegaard <dr@jones.dk>,
+ Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
  cdbs (>= 0.4.70~),
  devscripts,
- debhelper,
+ debhelper (>= 9),
  dh-buildinfo,
  cmake,
  libqt4-dev,
@@ -23,14 +25,16 @@
  libjack-dev,
  liblrdf-dev,
  libsndfile1-dev (>= 1.0.18),
+ librubberband-dev,
  portaudio19-dev,
  libportmidi-dev,
+ libpulse-dev,
  librsvg2-bin,
  netpbm
-Standards-Version: 3.9.3
+Standards-Version: 3.9.6
 Homepage: http://www.hydrogen-music.org/
-Vcs-Git: git://git.debian.org/git/pkg-multimedia/hydrogen.git
-Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/hydrogen.git;a=summary
+Vcs-Git: git://anonscm.debian.org/pkg-multimedia/hydrogen.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/hydrogen.git
 
 Package: hydrogen
 Architecture: any

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=3
opts=uversionmangle=s/-(beta|alpha|rc)/~$1/ \
https://github.com/hydrogen-music/hydrogen/tags .*/v?(\d\S*)\.tar\.gz
